OpenGL-2.8.0.0: A binding for the OpenGL graphics system

Portability | portable
Stability | stable
Maintainer | sven.panne@aedion.de
Safe Haskell | None

Graphics.Rendering.OpenGL.GL.Tensor

Description

This package contains tensor data types and their instances for some basic type classes.

Synopsis

- newtype Vertex1 a = Vertex1 a
- data Vertex2 a = Vertex2 !a !a
- data Vertex3 a = Vertex3 !a !a !a
- data Vertex4 a = Vertex4 !a !a !a !a
- newtype Vector1 a = Vector1 a
- data Vector2 a = Vector2 !a !a
- data Vector3 a = Vector3 !a !a !a
- data Vector4 a = Vector4 !a !a !a !a

# Documentation

newtype Vertex1 a

A vertex with y=0, z=0 and w=1.

Constructors

Vertex1 a |

Instances

Functor Vertex1 |
Typeable1 Vertex1 |
Applicative Vertex1 |
Foldable Vertex1 |
Traversable Vertex1 |
Bounded a => Bounded (Vertex1 a) |
Eq a => Eq (Vertex1 a) |
Ord a => Ord (Vertex1 a) |
Read a => Read (Vertex1 a) |
Show a => Show (Vertex1 a) |
Ix a => Ix (Vertex1 a) |
Typeable a => Typeable (Vertex1 a) |
Storable a => Storable (Vertex1 a) |
VertexAttribComponent a => VertexAttrib (Vertex1 a) |

data Vertex2 a

A vertex with z=0 and w=1.

Constructors

Vertex2 !a !a |

Instances

Functor Vertex2 |
Typeable1 Vertex2 |
Applicative Vertex2 |
Foldable Vertex2 |
Traversable Vertex2 |
TrimmingPoint Vertex2 |
Bounded a => Bounded (Vertex2 a) |
Eq a => Eq (Vertex2 a) |
Ord a => Ord (Vertex2 a) |
Read a => Read (Vertex2 a) |
Show a => Show (Vertex2 a) |
Ix a => Ix (Vertex2 a) |
Typeable a => Typeable (Vertex2 a) |
Storable a => Storable (Vertex2 a) |
VertexAttribComponent a => VertexAttrib (Vertex2 a) |
VertexComponent a => Vertex (Vertex2 a) |
WindowPosComponent a => WindowPos (Vertex2 a) |
RasterPosComponent a => RasterPos (Vertex2 a) |
UniformComponent a => Uniform (Vertex2 a) |

data Vertex3 a

A vertex with w=1.

Constructors

Vertex3 !a !a !a |

Instances

Functor Vertex3 |
Typeable1 Vertex3 |
Applicative Vertex3 |
Foldable Vertex3 |
Traversable Vertex3 |
ControlPoint Vertex3 |
TrimmingPoint Vertex3 |
Bounded a => Bounded (Vertex3 a) |
Eq a => Eq (Vertex3 a) |
Ord a => Ord (Vertex3 a) |
Read a => Read (Vertex3 a) |
Show a => Show (Vertex3 a) |
Ix a => Ix (Vertex3 a) |
Typeable a => Typeable (Vertex3 a) |
Storable a => Storable (Vertex3 a) |
VertexAttribComponent a => VertexAttrib (Vertex3 a) |
VertexComponent a => Vertex (Vertex3 a) |
WindowPosComponent a => WindowPos (Vertex3 a) |
RasterPosComponent a => RasterPos (Vertex3 a) |
UniformComponent a => Uniform (Vertex3 a) |

data Vertex4 a

A fully-fledged four-dimensional vertex.

Constructors

Vertex4 !a !a !a !a |

Instances

Functor Vertex4 |
Typeable1 Vertex4 |
Applicative Vertex4 |
Foldable Vertex4 |
Traversable Vertex4 |
ControlPoint Vertex4 |
Bounded a => Bounded (Vertex4 a) |
Eq a => Eq (Vertex4 a) |
Ord a => Ord (Vertex4 a) |
Read a => Read (Vertex4 a) |
Show a => Show (Vertex4 a) |
Ix a => Ix (Vertex4 a) |
Typeable a => Typeable (Vertex4 a) |
Storable a => Storable (Vertex4 a) |
VertexAttribComponent a => VertexAttrib (Vertex4 a) |
VertexComponent a => Vertex (Vertex4 a) |
RasterPosComponent a => RasterPos (Vertex4 a) |
UniformComponent a => Uniform (Vertex4 a) |

newtype Vector1 a

A one-dimensional vector.

Constructors

Vector1 a |

Instances

Functor Vector1 |
Typeable1 Vector1 |
Applicative Vector1 |
Foldable Vector1 |
Traversable Vector1 |
Bounded a => Bounded (Vector1 a) |
Eq a => Eq (Vector1 a) |
Ord a => Ord (Vector1 a) |
Read a => Read (Vector1 a) |
Show a => Show (Vector1 a) |
Ix a => Ix (Vector1 a) |
Typeable a => Typeable (Vector1 a) |
Storable a => Storable (Vector1 a) |
VertexAttribComponent a => VertexAttrib (Vector1 a) |

data Vector2 a

A two-dimensional vector.

Constructors

Vector2 !a !a |

Instances

Functor Vector2 |
Typeable1 Vector2 |
Applicative Vector2 |
Foldable Vector2 |
Traversable Vector2 |
Bounded a => Bounded (Vector2 a) |
Eq a => Eq (Vector2 a) |
Ord a => Ord (Vector2 a) |
Read a => Read (Vector2 a) |
Show a => Show (Vector2 a) |
Ix a => Ix (Vector2 a) |
Typeable a => Typeable (Vector2 a) |
Storable a => Storable (Vector2 a) |
VertexAttribComponent a => VertexAttrib (Vector2 a) |

data Vector3 a

A three-dimensional vector.

Constructors

Vector3 !a !a !a |

Instances

Functor Vector3 |
Typeable1 Vector3 |
Applicative Vector3 |
Foldable Vector3 |
Traversable Vector3 |
Bounded a => Bounded (Vector3 a) |
Eq a => Eq (Vector3 a) |
Ord a => Ord (Vector3 a) |
Read a => Read (Vector3 a) |
Show a => Show (Vector3 a) |
Ix a => Ix (Vector3 a) |
Typeable a => Typeable (Vector3 a) |
Storable a => Storable (Vector3 a) |
VertexAttribComponent a => VertexAttrib (Vector3 a) |

data Vector4 a

A four-dimensional vector.

Constructors

Vector4 !a !a !a !a |

Instances

Functor Vector4 |
Typeable1 Vector4 |
Applicative Vector4 |
Foldable Vector4 |
Traversable Vector4 |
Bounded a => Bounded (Vector4 a) |
Eq a => Eq (Vector4 a) |
Ord a => Ord (Vector4 a) |
Read a => Read (Vector4 a) |
Show a => Show (Vector4 a) |
Ix a => Ix (Vector4 a) |
Typeable a => Typeable (Vector4 a) |
Storable a => Storable (Vector4 a) |
VertexAttribComponent a => VertexAttrib (Vector4 a) |